<?php

namespace web\admin\ap;

class art_vent {
    static function setwhere($db, $post) {
        $query = $post->get('query');
        $csql = new \ciy\sql('ap_art_vent');
        $liid = objint($query, 'liid');
        if ($liid == 1)
            $csql->where('audituser=0');
        if ($liid == 2)
            $csql->where('audituser>0');
        $csql->where('sectionid', get('_sectionid'));
        $val = objstr($query, 'artid');
        if (!empty($val)) {
            $csqlt = new \ciy\sql('ap_art_post');
            $csqlt->where('name like', $val);
            $trow = $db->getone($csqlt);
            if (is_array($trow)) {
                $csql->where('artid', $trow['id']);
                $query['artid'] = $trow['name'];
            } else {
                $csql->where('artid=0');
            }
        }
        $val = objstr($query, 'vuser');
        if (!empty($val)) {
            $csqlt = new \ciy\sql('ap_user');
            $csqlt->where('name like', $val);
            $trow = $db->getone($csqlt);
            if (is_array($trow)) {
                $csql->where('vuser', $trow['id']);
                $query['vuser'] = $trow['name'];
            } else {
                $csql->where('vuser=0');
            }
        }
        $csql->where('content like', objstr($query, 'content'));
        $csql->wheredaterange('pubtimes', objstr($query, 'pubtimes'));
        $csql->where('audituser', objstr($query, 'audituser'));
        $order = objstr($query, 'order', 'id desc');
        $csql->order($order);
        $query['order'] = $order;
        return [$query, $csql];
    }

    public static function json_list() {
        global $db;
        $rsuser = verifyfast();
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $pageno = $post->getint('pageno', 1);
        $pagecount = $post->getint('pagecount', 10);
        $csql->limit($pageno, $pagecount);
        $mainrowcount = $post->getint('count');
        $rows = $db->get($csql, $mainrowcount);
        if ($rows === false)
            return errjson($db->error);
        $ret = array('searchwhere' => $where, 'pageno' => $pageno, 'pagecount' => $pagecount, 'count' => $mainrowcount, 'list' => $rows);
        if ($post->getbool('field')) {
            $field = array();
            $fshow = $db->getfield($field, 'ap_art_vent');
            foreach ($field as $fr => $v) {
                if (get('_' . $fr))
                    $field[$fr]['c'] = ',' . $field[$fr]['c'];
            }
            $fshow = fieldadd($fshow, $field, 0, '_btn', '操作');
            $ret['field'] = $field;
            $ret['fshow'] = $fshow;
        }
        if ($post->getbool('once')) {
            $ret['once'] = true;
            $input = array();
            $input[] = array('type' => 'input', 'form' => 'artid', 'name' => '文章', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'input', 'form' => 'vuser', 'name' => '所属用户', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'input', 'form' => 'content', 'name' => '内容', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'daterange', 'form' => 'pubtimes', 'name' => '反馈时间');
            $input[] = array('type' => 'select', 'form' => 'audituser', 'name' => '审核人', 'all' => '全部', 'select' => 'adminuser');
            $ret['searchinput'] = $input;
        }
        $ret['ap_art_section'] = getrelation($db, $rows, 'ap_art_section', 'sectionid');
        $ret['ap_art_post'] = getrelation($db, $rows, 'ap_art_post', 'artid');
        $ret['ap_user'] = getrelation($db, $rows, 'ap_user', 'vuser');
        return succjson($ret);
    }

    public static function json_del() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p d'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        $ids = $post->get('ids');
        if (empty($ids))
            return errjson('请选择至少一条');
        $csql = new \ciy\sql('ap_art_vent');
        $csql->where('id in', $ids);
        $rows = $db->get($csql);
        $vids = array();
        try {
            $db->begin();
            foreach ($rows as $row) {
                $delid = $row['id'];
                //delcheck($db, $delid, 'tablexx', 'xxid', '管理员');
                //delall($db, $delid, 'tablexx', 'xxid', '运动员');  //deltimeall
                delme($db, $delid, 'ap_art_vent');
                savelogdb($db, $rsuser['id'], 'ap_art_vent', $row, null);
                $vids[] = $delid;
            }
            $db->commit();
        } catch (\Exception $ex) {
            $db->rollback();
            savelogfile('err_db', $ex->getMessage());
            return errjson($ex->getMessage());
        }
        $ret['ids'] = $vids;
        return succjson($ret);
    }
    public static function json_read() {
        global $db;
        $rsuser = verifyfast();
        $post = new \ciy\post();
        $ids = $post->get('ids');
        if (empty($ids))
            return errjson('请选择至少一条');
        $updata = array();
        $updata['audituser'] = $rsuser['id'];
        $csql = new \ciy\sql('ap_art_vent');
        $csql->where('id in', $ids);
        if ($db->update($csql, $updata) === false)
            return errjson($db->error);
        $ret['data'] = $updata;
        $ret['ids'] = explode(',', $ids);
        return succjson($ret);
    }

    public static function json_exportxls() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p e'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $rows = $db->get($csql);
        if (count($rows) > 10000)
            return errjson('将导出' . count($rows) . '条，不建议超过1万条，请筛选缩小范围');
        $fields = array();
        $fields[] = array('style' => 'l', 'width' => 60,  'field' => 'id', 'name' => '行码');
        $fields[] = array('style' => 'c', 'width' => 100,  'field' => 'sectionid', 'name' => '版块');
        $fields[] = array('style' => 'c', 'width' => 100,  'field' => 'artid', 'name' => '版块');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'vuser', 'name' => '所属用户');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'content', 'name' => '内容');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'pubtimes', 'name' => '反馈时间');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'audituser', 'name' => '审核人');
        $code_sectionid = getrelation($db, $rows, 'ap_art_section', 'sectionid', 'id,name');
        $code_artid = getrelation($db, $rows, 'ap_art_post', 'artid', 'id,name');
        $code_vuser = getrelation($db, $rows, 'ap_user', 'vuser', 'id,name');
        $code_audituser = getcatas($db, 'adminuser');
        $datas = array();
        foreach ($rows as $row) {
            $dat = array();
            foreach ($fields as $field) {
                $field = $field['field'];
                $val = isset($row[$field]) ? $row[$field] : '';
                if ($field == 'id')
                    $val = enid($val);
                if ($field == 'sectionid')
                    $val = ccode($code_sectionid, $val);
                if ($field == 'artid')
                    $val = ccode($code_artid, $val);
                if ($field == 'vuser')
                    $val = ccode($code_vuser, $val);
                if ($field == 'pubtimes')
                    $val = ($val == 0 ? '--' : date('Y-m-d H:i', $val));
                if ($field == 'audituser')
                    $val = ccode($code_audituser, $val);
                $dat[] = $val;
            }
            $datas[] = $dat;
        }
        $param = array();
        $param['field'] = $fields;
        $param['data'] = $datas;
        $param['sheetname'] = '数据报表';
        $param['titleheight'] = '25'; //列头高度
        $param['landscape'] = true; //横向打印
        $param['fixtopage'] = true; //打印整个工作表
        $param['toptitle'] = 'Demo数据报表';
        $str = \ciy\excel::general_excel_xml($param);
        $filename = '';
        if (empty($filename))
            $filename = date('Y-m-d_H-i-s') . rand(1000, 9999);
        $filename .= '.xls';
        file_put_contents(PATH_WEB . 'ud/tmp/' . $filename, $str);
        return succjson(array('url' => '/ud/tmp/' . $filename));
    }
}
